# coding: utf-8

"""
    Ory Kratos

    Welcome to the ORY Kratos HTTP API documentation!  # noqa: E501

    The version of the OpenAPI document: v0.5.4-alpha.1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ory_kratos_client.configuration import Configuration


class Identity(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'recovery_addresses': 'list[RecoveryAddress]',
        'schema_id': 'str',
        'schema_url': 'str',
        'traits': 'object',
        'verifiable_addresses': 'list[VerifiableAddress]'
    }

    attribute_map = {
        'id': 'id',
        'recovery_addresses': 'recovery_addresses',
        'schema_id': 'schema_id',
        'schema_url': 'schema_url',
        'traits': 'traits',
        'verifiable_addresses': 'verifiable_addresses'
    }

    def __init__(self, id=None, recovery_addresses=None, schema_id=None, schema_url=None, traits=None, verifiable_addresses=None, local_vars_configuration=None):  # noqa: E501
        """Identity - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._recovery_addresses = None
        self._schema_id = None
        self._schema_url = None
        self._traits = None
        self._verifiable_addresses = None
        self.discriminator = None

        self.id = id
        if recovery_addresses is not None:
            self.recovery_addresses = recovery_addresses
        self.schema_id = schema_id
        self.schema_url = schema_url
        self.traits = traits
        if verifiable_addresses is not None:
            self.verifiable_addresses = verifiable_addresses

    @property
    def id(self):
        """Gets the id of this Identity.  # noqa: E501


        :return: The id of this Identity.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Identity.


        :param id: The id of this Identity.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def recovery_addresses(self):
        """Gets the recovery_addresses of this Identity.  # noqa: E501

        RecoveryAddresses contains all the addresses that can be used to recover an identity.  # noqa: E501

        :return: The recovery_addresses of this Identity.  # noqa: E501
        :rtype: list[RecoveryAddress]
        """
        return self._recovery_addresses

    @recovery_addresses.setter
    def recovery_addresses(self, recovery_addresses):
        """Sets the recovery_addresses of this Identity.

        RecoveryAddresses contains all the addresses that can be used to recover an identity.  # noqa: E501

        :param recovery_addresses: The recovery_addresses of this Identity.  # noqa: E501
        :type: list[RecoveryAddress]
        """

        self._recovery_addresses = recovery_addresses

    @property
    def schema_id(self):
        """Gets the schema_id of this Identity.  # noqa: E501

        SchemaID is the ID of the JSON Schema to be used for validating the identity's traits.  # noqa: E501

        :return: The schema_id of this Identity.  # noqa: E501
        :rtype: str
        """
        return self._schema_id

    @schema_id.setter
    def schema_id(self, schema_id):
        """Sets the schema_id of this Identity.

        SchemaID is the ID of the JSON Schema to be used for validating the identity's traits.  # noqa: E501

        :param schema_id: The schema_id of this Identity.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and schema_id is None:  # noqa: E501
            raise ValueError("Invalid value for `schema_id`, must not be `None`")  # noqa: E501

        self._schema_id = schema_id

    @property
    def schema_url(self):
        """Gets the schema_url of this Identity.  # noqa: E501

        SchemaURL is the URL of the endpoint where the identity's traits schema can be fetched from.  format: url  # noqa: E501

        :return: The schema_url of this Identity.  # noqa: E501
        :rtype: str
        """
        return self._schema_url

    @schema_url.setter
    def schema_url(self, schema_url):
        """Sets the schema_url of this Identity.

        SchemaURL is the URL of the endpoint where the identity's traits schema can be fetched from.  format: url  # noqa: E501

        :param schema_url: The schema_url of this Identity.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and schema_url is None:  # noqa: E501
            raise ValueError("Invalid value for `schema_url`, must not be `None`")  # noqa: E501

        self._schema_url = schema_url

    @property
    def traits(self):
        """Gets the traits of this Identity.  # noqa: E501


        :return: The traits of this Identity.  # noqa: E501
        :rtype: object
        """
        return self._traits

    @traits.setter
    def traits(self, traits):
        """Sets the traits of this Identity.


        :param traits: The traits of this Identity.  # noqa: E501
        :type: object
        """
        if self.local_vars_configuration.client_side_validation and traits is None:  # noqa: E501
            raise ValueError("Invalid value for `traits`, must not be `None`")  # noqa: E501

        self._traits = traits

    @property
    def verifiable_addresses(self):
        """Gets the verifiable_addresses of this Identity.  # noqa: E501

        VerifiableAddresses contains all the addresses that can be verified by the user.  # noqa: E501

        :return: The verifiable_addresses of this Identity.  # noqa: E501
        :rtype: list[VerifiableAddress]
        """
        return self._verifiable_addresses

    @verifiable_addresses.setter
    def verifiable_addresses(self, verifiable_addresses):
        """Sets the verifiable_addresses of this Identity.

        VerifiableAddresses contains all the addresses that can be verified by the user.  # noqa: E501

        :param verifiable_addresses: The verifiable_addresses of this Identity.  # noqa: E501
        :type: list[VerifiableAddress]
        """

        self._verifiable_addresses = verifiable_addresses

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Identity):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Identity):
            return True

        return self.to_dict() != other.to_dict()
